=== debian/changelog ===
sdbus-cpp (1.4.0-2) unstable; urgency=medium

  * Cherry pick upstream patch to fix resolving libsystemd dependency with
    pkgconfig (Closes: #1059422)

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 30 Dec 2023 05:00:40 +0800

sdbus-cpp (1.4.0-1) unstable; urgency=medium

  * New upstream release
  * skip GetMachineId test when /etc/machine-id doesn't exist

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 06 Nov 2023 21:51:25 +0800
