=== tools/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 cmake_minimum_required(VERSION 3.5)
 
-project(sdbus-c++-tools VERSION 1.4.0)
+project(sdbus-c++-tools VERSION 1.6.0)
 
 include(GNUInstallDirs)
