=== debian/changelog ===
sdbus-cpp (1.6.0-1) unstable; urgency=medium

  * New upstream release
    + Fix FTBFS with GCC-14(Closes: #1075446)
  * Drop patches applied in new version

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 29 Jul 2024 10:12:17 +0800
